using System;
using System.Threading;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using AddiData.ADDISocket;

namespace CompareLogic
{
	/// <summary>
	/// Zusammenfassung fr CompareLogic.
	/// </summary>
	public class CompareLogic : System.Windows.Forms.Form
    {
        private System.Windows.Forms.GroupBox groupBox2;
        private System.Windows.Forms.Label label1;
        private GroupBox GB_CounterConfig;
        private Label L_IC_Label1;
        private ComboBox LB_SC_ValueFormat;
        private CheckBox CB_Counter3;
        private CheckBox CB_Counter2;
        private CheckBox CB_Counter1;
        private CheckBox CB_Counter0;
        private Label label2;
        private GroupBox GB_Help;
        private Label L_Help;
        private GroupBox GB_Compare;
        private TextBox TB_TransferNbr;
        private Label label8;
        private Button B_CounterInitialisation;
        private Button B_ClearCounter;
        private Button B_StartCompare;
        private Button B_StopCompare;
        private Button B_CounterReleaseInitialisation;
        private GroupBox GB_AcquisitionInfo;
        internal TextBox TB_Values;
        private System.Windows.Forms.Timer DisplayTimer;
        private GroupBox GB_ModuleInfo;
        private Button B_Connect;
        private Label label3;
        private Label label4;
        private Label label5;
        private TextBox TB_IPAddress_3;
        private TextBox TB_IPAddress_2;
        private TextBox TB_IPAddress_1;
        private TextBox TB_IPAddress_0;
        private Label label19;
        private Label L_MSXEInfo;
        private Label label6;
        private TextBox TB_SC_SignalPeriod;
        private Label label9;
        private ComboBox LB_SC_Resolution;
        private Label label12;
        private Label L_Frequency;
        private RadioButton RB_Counter0;
        private Label label13;
        private RadioButton RB_Counter3;
        private RadioButton RB_Counter2;
        private RadioButton RB_Counter1;
        private TextBox TB_CompareValue;
        private Label L_Compare;
        private ComboBox LB_CompareLogic;
        private ComboBox LB_SynchroTrigger;
        private Label label10;
        private Label label11;
        private GroupBox GB_Counter;
        internal TextBox TB_CounterCompare;
        private System.Windows.Forms.Timer ReadCounterTimer;
        private System.ComponentModel.IContainer components;

        public class ListData
        {
            private string myItem;
            private long myValue;

            public ListData(string strItem, long lValue)
            {

                this.myItem = strItem;
                this.myValue = lValue;
            }

            public string Item
            {
                get { return myItem; }
            }

            public long Value
            {

                get { return myValue; }
            }
        }

		public CompareLogic()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(CompareLogic));
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.label1 = new System.Windows.Forms.Label();
            this.GB_CounterConfig = new System.Windows.Forms.GroupBox();
            this.L_Frequency = new System.Windows.Forms.Label();
            this.TB_SC_SignalPeriod = new System.Windows.Forms.TextBox();
            this.label12 = new System.Windows.Forms.Label();
            this.RB_Counter3 = new System.Windows.Forms.RadioButton();
            this.L_IC_Label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.RB_Counter2 = new System.Windows.Forms.RadioButton();
            this.LB_SC_ValueFormat = new System.Windows.Forms.ComboBox();
            this.LB_SC_Resolution = new System.Windows.Forms.ComboBox();
            this.RB_Counter0 = new System.Windows.Forms.RadioButton();
            this.RB_Counter1 = new System.Windows.Forms.RadioButton();
            this.CB_Counter3 = new System.Windows.Forms.CheckBox();
            this.CB_Counter2 = new System.Windows.Forms.CheckBox();
            this.CB_Counter1 = new System.Windows.Forms.CheckBox();
            this.CB_Counter0 = new System.Windows.Forms.CheckBox();
            this.GB_Help = new System.Windows.Forms.GroupBox();
            this.L_Help = new System.Windows.Forms.Label();
            this.GB_Compare = new System.Windows.Forms.GroupBox();
            this.TB_CompareValue = new System.Windows.Forms.TextBox();
            this.label11 = new System.Windows.Forms.Label();
            this.label10 = new System.Windows.Forms.Label();
            this.L_Compare = new System.Windows.Forms.Label();
            this.TB_TransferNbr = new System.Windows.Forms.TextBox();
            this.label8 = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.LB_SynchroTrigger = new System.Windows.Forms.ComboBox();
            this.LB_CompareLogic = new System.Windows.Forms.ComboBox();
            this.B_CounterInitialisation = new System.Windows.Forms.Button();
            this.B_ClearCounter = new System.Windows.Forms.Button();
            this.B_StartCompare = new System.Windows.Forms.Button();
            this.B_StopCompare = new System.Windows.Forms.Button();
            this.B_CounterReleaseInitialisation = new System.Windows.Forms.Button();
            this.GB_AcquisitionInfo = new System.Windows.Forms.GroupBox();
            this.TB_Values = new System.Windows.Forms.TextBox();
            this.DisplayTimer = new System.Windows.Forms.Timer(this.components);
            this.GB_ModuleInfo = new System.Windows.Forms.GroupBox();
            this.L_MSXEInfo = new System.Windows.Forms.Label();
            this.B_Connect = new System.Windows.Forms.Button();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.TB_IPAddress_3 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_2 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_1 = new System.Windows.Forms.TextBox();
            this.TB_IPAddress_0 = new System.Windows.Forms.TextBox();
            this.label19 = new System.Windows.Forms.Label();
            this.GB_Counter = new System.Windows.Forms.GroupBox();
            this.TB_CounterCompare = new System.Windows.Forms.TextBox();
            this.ReadCounterTimer = new System.Windows.Forms.Timer(this.components);
            this.groupBox2.SuspendLayout();
            this.GB_CounterConfig.SuspendLayout();
            this.GB_Help.SuspendLayout();
            this.GB_Compare.SuspendLayout();
            this.GB_AcquisitionInfo.SuspendLayout();
            this.GB_ModuleInfo.SuspendLayout();
            this.GB_Counter.SuspendLayout();
            this.SuspendLayout();
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.label1);
            this.groupBox2.Location = new System.Drawing.Point(8, 8);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(928, 48);
            this.groupBox2.TabIndex = 10;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Description";
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 16);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(914, 24);
            this.label1.TabIndex = 0;
            this.label1.Text = "This sample test the compare logic latch event";
            // 
            // GB_CounterConfig
            // 
            this.GB_CounterConfig.Controls.Add(this.L_Frequency);
            this.GB_CounterConfig.Controls.Add(this.TB_SC_SignalPeriod);
            this.GB_CounterConfig.Controls.Add(this.label12);
            this.GB_CounterConfig.Controls.Add(this.RB_Counter3);
            this.GB_CounterConfig.Controls.Add(this.L_IC_Label1);
            this.GB_CounterConfig.Controls.Add(this.label2);
            this.GB_CounterConfig.Controls.Add(this.label9);
            this.GB_CounterConfig.Controls.Add(this.label6);
            this.GB_CounterConfig.Controls.Add(this.RB_Counter2);
            this.GB_CounterConfig.Controls.Add(this.LB_SC_ValueFormat);
            this.GB_CounterConfig.Controls.Add(this.LB_SC_Resolution);
            this.GB_CounterConfig.Controls.Add(this.RB_Counter0);
            this.GB_CounterConfig.Controls.Add(this.RB_Counter1);
            this.GB_CounterConfig.Location = new System.Drawing.Point(8, 194);
            this.GB_CounterConfig.Name = "GB_CounterConfig";
            this.GB_CounterConfig.Size = new System.Drawing.Size(362, 170);
            this.GB_CounterConfig.TabIndex = 76;
            this.GB_CounterConfig.TabStop = false;
            this.GB_CounterConfig.Text = "Counter(s) configuration";
            // 
            // L_Frequency
            // 
            this.L_Frequency.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_Frequency.ForeColor = System.Drawing.Color.Blue;
            this.L_Frequency.Location = new System.Drawing.Point(173, 135);
            this.L_Frequency.Name = "L_Frequency";
            this.L_Frequency.Size = new System.Drawing.Size(149, 13);
            this.L_Frequency.TabIndex = 49;
            // 
            // TB_SC_SignalPeriod
            // 
            this.TB_SC_SignalPeriod.Location = new System.Drawing.Point(175, 76);
            this.TB_SC_SignalPeriod.Name = "TB_SC_SignalPeriod";
            this.TB_SC_SignalPeriod.Size = new System.Drawing.Size(146, 20);
            this.TB_SC_SignalPeriod.TabIndex = 48;
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label12.Location = new System.Drawing.Point(44, 135);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(126, 13);
            this.label12.TabIndex = 47;
            this.label12.Text = "Max. input frequency";
            // 
            // RB_Counter3
            // 
            this.RB_Counter3.AutoSize = true;
            this.RB_Counter3.Location = new System.Drawing.Point(269, 29);
            this.RB_Counter3.Name = "RB_Counter3";
            this.RB_Counter3.Size = new System.Drawing.Size(31, 17);
            this.RB_Counter3.TabIndex = 50;
            this.RB_Counter3.Text = "3";
            this.RB_Counter3.UseVisualStyleBackColor = true;
            this.RB_Counter3.CheckedChanged += new System.EventHandler(this.RB_CounterX_CheckedChanged);
            // 
            // L_IC_Label1
            // 
            this.L_IC_Label1.AutoSize = true;
            this.L_IC_Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.L_IC_Label1.Location = new System.Drawing.Point(44, 105);
            this.L_IC_Label1.Name = "L_IC_Label1";
            this.L_IC_Label1.Size = new System.Drawing.Size(66, 13);
            this.L_IC_Label1.TabIndex = 47;
            this.L_IC_Label1.Text = "Value format";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label2.Location = new System.Drawing.Point(44, 31);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(89, 13);
            this.label2.TabIndex = 46;
            this.label2.Text = "Counter selection";
            // 
            // label9
            // 
            this.label9.AutoSize = true;
            this.label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label9.Location = new System.Drawing.Point(44, 53);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(57, 13);
            this.label9.TabIndex = 46;
            this.label9.Text = "Resolution";
            // 
            // label6
            // 
            this.label6.AutoSize = true;
            this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label6.Location = new System.Drawing.Point(44, 78);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(125, 13);
            this.label6.TabIndex = 46;
            this.label6.Text = "Signal period (m/period)";
            // 
            // RB_Counter2
            // 
            this.RB_Counter2.AutoSize = true;
            this.RB_Counter2.Location = new System.Drawing.Point(238, 29);
            this.RB_Counter2.Name = "RB_Counter2";
            this.RB_Counter2.Size = new System.Drawing.Size(31, 17);
            this.RB_Counter2.TabIndex = 50;
            this.RB_Counter2.Text = "2";
            this.RB_Counter2.UseVisualStyleBackColor = true;
            this.RB_Counter2.CheckedChanged += new System.EventHandler(this.RB_CounterX_CheckedChanged);
            // 
            // LB_SC_ValueFormat
            // 
            this.LB_SC_ValueFormat.AllowDrop = true;
            this.LB_SC_ValueFormat.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LB_SC_ValueFormat.FormattingEnabled = true;
            this.LB_SC_ValueFormat.Location = new System.Drawing.Point(175, 105);
            this.LB_SC_ValueFormat.Name = "LB_SC_ValueFormat";
            this.LB_SC_ValueFormat.Size = new System.Drawing.Size(146, 21);
            this.LB_SC_ValueFormat.TabIndex = 9;
            this.LB_SC_ValueFormat.SelectedIndexChanged += new System.EventHandler(this.LB_SC_ValueFormat_SelectedIndexChanged);
            // 
            // LB_SC_Resolution
            // 
            this.LB_SC_Resolution.AllowDrop = true;
            this.LB_SC_Resolution.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LB_SC_Resolution.FormattingEnabled = true;
            this.LB_SC_Resolution.Location = new System.Drawing.Point(176, 48);
            this.LB_SC_Resolution.Name = "LB_SC_Resolution";
            this.LB_SC_Resolution.Size = new System.Drawing.Size(146, 21);
            this.LB_SC_Resolution.TabIndex = 8;
            // 
            // RB_Counter0
            // 
            this.RB_Counter0.AutoSize = true;
            this.RB_Counter0.Location = new System.Drawing.Point(176, 29);
            this.RB_Counter0.Name = "RB_Counter0";
            this.RB_Counter0.Size = new System.Drawing.Size(31, 17);
            this.RB_Counter0.TabIndex = 50;
            this.RB_Counter0.Text = "0";
            this.RB_Counter0.UseVisualStyleBackColor = true;
            this.RB_Counter0.CheckedChanged += new System.EventHandler(this.RB_CounterX_CheckedChanged);
            // 
            // RB_Counter1
            // 
            this.RB_Counter1.AutoSize = true;
            this.RB_Counter1.Location = new System.Drawing.Point(207, 29);
            this.RB_Counter1.Name = "RB_Counter1";
            this.RB_Counter1.Size = new System.Drawing.Size(31, 17);
            this.RB_Counter1.TabIndex = 50;
            this.RB_Counter1.Text = "1";
            this.RB_Counter1.UseVisualStyleBackColor = true;
            this.RB_Counter1.CheckedChanged += new System.EventHandler(this.RB_CounterX_CheckedChanged);
            // 
            // CB_Counter3
            // 
            this.CB_Counter3.AutoSize = true;
            this.CB_Counter3.Location = new System.Drawing.Point(333, 30);
            this.CB_Counter3.Name = "CB_Counter3";
            this.CB_Counter3.Size = new System.Drawing.Size(32, 17);
            this.CB_Counter3.TabIndex = 7;
            this.CB_Counter3.Text = "3";
            this.CB_Counter3.UseVisualStyleBackColor = true;
            this.CB_Counter3.CheckedChanged += new System.EventHandler(this.CB_CounterX_CheckedChanged);
            // 
            // CB_Counter2
            // 
            this.CB_Counter2.AutoSize = true;
            this.CB_Counter2.Location = new System.Drawing.Point(295, 30);
            this.CB_Counter2.Name = "CB_Counter2";
            this.CB_Counter2.Size = new System.Drawing.Size(32, 17);
            this.CB_Counter2.TabIndex = 6;
            this.CB_Counter2.Text = "2";
            this.CB_Counter2.UseVisualStyleBackColor = true;
            this.CB_Counter2.CheckedChanged += new System.EventHandler(this.CB_CounterX_CheckedChanged);
            // 
            // CB_Counter1
            // 
            this.CB_Counter1.AutoSize = true;
            this.CB_Counter1.Location = new System.Drawing.Point(257, 30);
            this.CB_Counter1.Name = "CB_Counter1";
            this.CB_Counter1.Size = new System.Drawing.Size(32, 17);
            this.CB_Counter1.TabIndex = 5;
            this.CB_Counter1.Text = "1";
            this.CB_Counter1.UseVisualStyleBackColor = true;
            this.CB_Counter1.CheckedChanged += new System.EventHandler(this.CB_CounterX_CheckedChanged);
            // 
            // CB_Counter0
            // 
            this.CB_Counter0.AutoSize = true;
            this.CB_Counter0.Location = new System.Drawing.Point(217, 30);
            this.CB_Counter0.Name = "CB_Counter0";
            this.CB_Counter0.Size = new System.Drawing.Size(32, 17);
            this.CB_Counter0.TabIndex = 4;
            this.CB_Counter0.Text = "0";
            this.CB_Counter0.UseVisualStyleBackColor = true;
            this.CB_Counter0.CheckedChanged += new System.EventHandler(this.CB_CounterX_CheckedChanged);
            // 
            // GB_Help
            // 
            this.GB_Help.Controls.Add(this.L_Help);
            this.GB_Help.Location = new System.Drawing.Point(8, 62);
            this.GB_Help.Name = "GB_Help";
            this.GB_Help.Size = new System.Drawing.Size(928, 56);
            this.GB_Help.TabIndex = 93;
            this.GB_Help.TabStop = false;
            this.GB_Help.Text = "Help";
            // 
            // L_Help
            // 
            this.L_Help.Location = new System.Drawing.Point(8, 16);
            this.L_Help.Name = "L_Help";
            this.L_Help.Size = new System.Drawing.Size(914, 32);
            this.L_Help.TabIndex = 0;
            this.L_Help.Text = resources.GetString("L_Help.Text");
            this.L_Help.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // GB_Compare
            // 
            this.GB_Compare.Controls.Add(this.TB_CompareValue);
            this.GB_Compare.Controls.Add(this.label11);
            this.GB_Compare.Controls.Add(this.label10);
            this.GB_Compare.Controls.Add(this.L_Compare);
            this.GB_Compare.Controls.Add(this.CB_Counter3);
            this.GB_Compare.Controls.Add(this.CB_Counter2);
            this.GB_Compare.Controls.Add(this.TB_TransferNbr);
            this.GB_Compare.Controls.Add(this.CB_Counter1);
            this.GB_Compare.Controls.Add(this.CB_Counter0);
            this.GB_Compare.Controls.Add(this.label8);
            this.GB_Compare.Controls.Add(this.label13);
            this.GB_Compare.Controls.Add(this.LB_SynchroTrigger);
            this.GB_Compare.Controls.Add(this.LB_CompareLogic);
            this.GB_Compare.Location = new System.Drawing.Point(386, 194);
            this.GB_Compare.Name = "GB_Compare";
            this.GB_Compare.Size = new System.Drawing.Size(550, 170);
            this.GB_Compare.TabIndex = 94;
            this.GB_Compare.TabStop = false;
            this.GB_Compare.Text = "Compare logic configuration";
            // 
            // TB_CompareValue
            // 
            this.TB_CompareValue.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_CompareValue.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_CompareValue.Location = new System.Drawing.Point(217, 50);
            this.TB_CompareValue.MaxLength = 10;
            this.TB_CompareValue.Name = "TB_CompareValue";
            this.TB_CompareValue.Size = new System.Drawing.Size(264, 20);
            this.TB_CompareValue.TabIndex = 90;
            this.TB_CompareValue.Text = "1";
            // 
            // label11
            // 
            this.label11.AutoSize = true;
            this.label11.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.label11.Location = new System.Drawing.Point(45, 105);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(78, 13);
            this.label11.TabIndex = 89;
            this.label11.Text = "Synchro trigger";
            // 
            // label10
            // 
            this.label10.AutoSize = true;
            this.label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.label10.Location = new System.Drawing.Point(45, 78);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(78, 13);
            this.label10.TabIndex = 89;
            this.label10.Text = "Compare mode";
            // 
            // L_Compare
            // 
            this.L_Compare.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.L_Compare.Location = new System.Drawing.Point(45, 53);
            this.L_Compare.Name = "L_Compare";
            this.L_Compare.Size = new System.Drawing.Size(184, 16);
            this.L_Compare.TabIndex = 89;
            this.L_Compare.Text = "Selected compare value";
            // 
            // TB_TransferNbr
            // 
            this.TB_TransferNbr.Location = new System.Drawing.Point(353, 132);
            this.TB_TransferNbr.Name = "TB_TransferNbr";
            this.TB_TransferNbr.Size = new System.Drawing.Size(128, 20);
            this.TB_TransferNbr.TabIndex = 11;
            this.TB_TransferNbr.Text = "1";
            // 
            // label8
            // 
            this.label8.AutoSize = true;
            this.label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label8.Location = new System.Drawing.Point(45, 135);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(302, 13);
            this.label8.TabIndex = 88;
            this.label8.Text = "Nbr of compares to acquire before the data are sent  (1 to 200)";
            // 
            // label13
            // 
            this.label13.AutoSize = true;
            this.label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label13.Location = new System.Drawing.Point(45, 31);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(141, 13);
            this.label13.TabIndex = 46;
            this.label13.Text = "Latched counter(s) selection";
            // 
            // LB_SynchroTrigger
            // 
            this.LB_SynchroTrigger.AllowDrop = true;
            this.LB_SynchroTrigger.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LB_SynchroTrigger.FormattingEnabled = true;
            this.LB_SynchroTrigger.Location = new System.Drawing.Point(217, 102);
            this.LB_SynchroTrigger.Name = "LB_SynchroTrigger";
            this.LB_SynchroTrigger.Size = new System.Drawing.Size(264, 21);
            this.LB_SynchroTrigger.TabIndex = 8;
            // 
            // LB_CompareLogic
            // 
            this.LB_CompareLogic.AllowDrop = true;
            this.LB_CompareLogic.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.LB_CompareLogic.FormattingEnabled = true;
            this.LB_CompareLogic.Location = new System.Drawing.Point(217, 75);
            this.LB_CompareLogic.Name = "LB_CompareLogic";
            this.LB_CompareLogic.Size = new System.Drawing.Size(264, 21);
            this.LB_CompareLogic.TabIndex = 8;
            // 
            // B_CounterInitialisation
            // 
            this.B_CounterInitialisation.Enabled = false;
            this.B_CounterInitialisation.Location = new System.Drawing.Point(8, 370);
            this.B_CounterInitialisation.Name = "B_CounterInitialisation";
            this.B_CounterInitialisation.Size = new System.Drawing.Size(173, 29);
            this.B_CounterInitialisation.TabIndex = 14;
            this.B_CounterInitialisation.Text = "Counter initialisation";
            this.B_CounterInitialisation.UseVisualStyleBackColor = true;
            this.B_CounterInitialisation.Click += new System.EventHandler(this.B_CounterInitialisation_Click);
            // 
            // B_ClearCounter
            // 
            this.B_ClearCounter.Enabled = false;
            this.B_ClearCounter.Location = new System.Drawing.Point(386, 370);
            this.B_ClearCounter.Name = "B_ClearCounter";
            this.B_ClearCounter.Size = new System.Drawing.Size(173, 29);
            this.B_ClearCounter.TabIndex = 16;
            this.B_ClearCounter.Text = "Clear counter(s)";
            this.B_ClearCounter.UseVisualStyleBackColor = true;
            this.B_ClearCounter.Click += new System.EventHandler(this.B_ClearCounter_Click);
            // 
            // B_StartCompare
            // 
            this.B_StartCompare.Enabled = false;
            this.B_StartCompare.Location = new System.Drawing.Point(575, 370);
            this.B_StartCompare.Name = "B_StartCompare";
            this.B_StartCompare.Size = new System.Drawing.Size(173, 29);
            this.B_StartCompare.TabIndex = 19;
            this.B_StartCompare.Text = "Start the compare logic";
            this.B_StartCompare.UseVisualStyleBackColor = true;
            this.B_StartCompare.Click += new System.EventHandler(this.B_StartCompare_Click);
            // 
            // B_StopCompare
            // 
            this.B_StopCompare.Enabled = false;
            this.B_StopCompare.Location = new System.Drawing.Point(764, 370);
            this.B_StopCompare.Name = "B_StopCompare";
            this.B_StopCompare.Size = new System.Drawing.Size(173, 29);
            this.B_StopCompare.TabIndex = 20;
            this.B_StopCompare.Text = "Stop the compare logic";
            this.B_StopCompare.UseVisualStyleBackColor = true;
            this.B_StopCompare.Click += new System.EventHandler(this.B_StopCompare_Click);
            // 
            // B_CounterReleaseInitialisation
            // 
            this.B_CounterReleaseInitialisation.Enabled = false;
            this.B_CounterReleaseInitialisation.Location = new System.Drawing.Point(197, 370);
            this.B_CounterReleaseInitialisation.Name = "B_CounterReleaseInitialisation";
            this.B_CounterReleaseInitialisation.Size = new System.Drawing.Size(173, 29);
            this.B_CounterReleaseInitialisation.TabIndex = 15;
            this.B_CounterReleaseInitialisation.Text = "Release counter initialisation";
            this.B_CounterReleaseInitialisation.UseVisualStyleBackColor = true;
            this.B_CounterReleaseInitialisation.Click += new System.EventHandler(this.B_CounterReleaseInitialisation_Click);
            // 
            // GB_AcquisitionInfo
            // 
            this.GB_AcquisitionInfo.Controls.Add(this.TB_Values);
            this.GB_AcquisitionInfo.Location = new System.Drawing.Point(8, 486);
            this.GB_AcquisitionInfo.Name = "GB_AcquisitionInfo";
            this.GB_AcquisitionInfo.Size = new System.Drawing.Size(934, 138);
            this.GB_AcquisitionInfo.TabIndex = 99;
            this.GB_AcquisitionInfo.TabStop = false;
            this.GB_AcquisitionInfo.Text = "Compare information";
            // 
            // TB_Values
            // 
            this.TB_Values.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_Values.Location = new System.Drawing.Point(11, 19);
            this.TB_Values.Multiline = true;
            this.TB_Values.Name = "TB_Values";
            this.TB_Values.ReadOnly = true;
            this.TB_Values.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.TB_Values.Size = new System.Drawing.Size(917, 107);
            this.TB_Values.TabIndex = 140;
            this.TB_Values.TabStop = false;
            // 
            // DisplayTimer
            // 
            this.DisplayTimer.Interval = 1;
            this.DisplayTimer.Tick += new System.EventHandler(this.DisplayTimer_Tick);
            // 
            // GB_ModuleInfo
            // 
            this.GB_ModuleInfo.Controls.Add(this.L_MSXEInfo);
            this.GB_ModuleInfo.Controls.Add(this.B_Connect);
            this.GB_ModuleInfo.Controls.Add(this.label3);
            this.GB_ModuleInfo.Controls.Add(this.label4);
            this.GB_ModuleInfo.Controls.Add(this.label5);
            this.GB_ModuleInfo.Controls.Add(this.TB_IPAddress_3);
            this.GB_ModuleInfo.Controls.Add(this.TB_IPAddress_2);
            this.GB_ModuleInfo.Controls.Add(this.TB_IPAddress_1);
            this.GB_ModuleInfo.Controls.Add(this.TB_IPAddress_0);
            this.GB_ModuleInfo.Controls.Add(this.label19);
            this.GB_ModuleInfo.Location = new System.Drawing.Point(8, 130);
            this.GB_ModuleInfo.Name = "GB_ModuleInfo";
            this.GB_ModuleInfo.Size = new System.Drawing.Size(928, 58);
            this.GB_ModuleInfo.TabIndex = 100;
            this.GB_ModuleInfo.TabStop = false;
            this.GB_ModuleInfo.Text = "Module selection";
            // 
            // L_MSXEInfo
            // 
            this.L_MSXEInfo.Location = new System.Drawing.Point(544, 13);
            this.L_MSXEInfo.Name = "L_MSXEInfo";
            this.L_MSXEInfo.Size = new System.Drawing.Size(378, 36);
            this.L_MSXEInfo.TabIndex = 102;
            this.L_MSXEInfo.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
            // 
            // B_Connect
            // 
            this.B_Connect.Location = new System.Drawing.Point(447, 20);
            this.B_Connect.Name = "B_Connect";
            this.B_Connect.Size = new System.Drawing.Size(91, 29);
            this.B_Connect.TabIndex = 97;
            this.B_Connect.Text = "Connect";
            this.B_Connect.UseVisualStyleBackColor = true;
            this.B_Connect.Click += new System.EventHandler(this.B_Connect_Click);
            // 
            // label3
            // 
            this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label3.Location = new System.Drawing.Point(393, 25);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(8, 16);
            this.label3.TabIndex = 101;
            this.label3.Text = "-";
            // 
            // label4
            // 
            this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label4.Location = new System.Drawing.Point(337, 25);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(8, 16);
            this.label4.TabIndex = 100;
            this.label4.Text = "-";
            // 
            // label5
            // 
            this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label5.Location = new System.Drawing.Point(281, 25);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(8, 16);
            this.label5.TabIndex = 99;
            this.label5.Text = "-";
            // 
            // TB_IPAddress_3
            // 
            this.TB_IPAddress_3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_3.Location = new System.Drawing.Point(409, 25);
            this.TB_IPAddress_3.MaxLength = 3;
            this.TB_IPAddress_3.Name = "TB_IPAddress_3";
            this.TB_IPAddress_3.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_3.TabIndex = 96;
            // 
            // TB_IPAddress_2
            // 
            this.TB_IPAddress_2.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_2.Location = new System.Drawing.Point(353, 25);
            this.TB_IPAddress_2.MaxLength = 3;
            this.TB_IPAddress_2.Name = "TB_IPAddress_2";
            this.TB_IPAddress_2.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_2.TabIndex = 95;
            // 
            // TB_IPAddress_1
            // 
            this.TB_IPAddress_1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_1.Location = new System.Drawing.Point(297, 25);
            this.TB_IPAddress_1.MaxLength = 3;
            this.TB_IPAddress_1.Name = "TB_IPAddress_1";
            this.TB_IPAddress_1.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_1.TabIndex = 94;
            // 
            // TB_IPAddress_0
            // 
            this.TB_IPAddress_0.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F);
            this.TB_IPAddress_0.ImeMode = System.Windows.Forms.ImeMode.Disable;
            this.TB_IPAddress_0.Location = new System.Drawing.Point(241, 25);
            this.TB_IPAddress_0.MaxLength = 3;
            this.TB_IPAddress_0.Name = "TB_IPAddress_0";
            this.TB_IPAddress_0.Size = new System.Drawing.Size(32, 20);
            this.TB_IPAddress_0.TabIndex = 93;
            // 
            // label19
            // 
            this.label19.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.label19.Location = new System.Drawing.Point(27, 27);
            this.label19.Name = "label19";
            this.label19.Size = new System.Drawing.Size(208, 16);
            this.label19.TabIndex = 98;
            this.label19.Text = "IP address of the MSX-E17xx module :";
            // 
            // GB_Counter
            // 
            this.GB_Counter.Controls.Add(this.TB_CounterCompare);
            this.GB_Counter.Location = new System.Drawing.Point(8, 405);
            this.GB_Counter.Name = "GB_Counter";
            this.GB_Counter.Size = new System.Drawing.Size(934, 75);
            this.GB_Counter.TabIndex = 99;
            this.GB_Counter.TabStop = false;
            this.GB_Counter.Text = "Compare counter information";
            // 
            // TB_CounterCompare
            // 
            this.TB_CounterCompare.Font = new System.Drawing.Font("Courier New", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.TB_CounterCompare.Location = new System.Drawing.Point(11, 19);
            this.TB_CounterCompare.Multiline = true;
            this.TB_CounterCompare.Name = "TB_CounterCompare";
            this.TB_CounterCompare.ReadOnly = true;
            this.TB_CounterCompare.ScrollBars = System.Windows.Forms.ScrollBars.Both;
            this.TB_CounterCompare.Size = new System.Drawing.Size(917, 39);
            this.TB_CounterCompare.TabIndex = 140;
            this.TB_CounterCompare.TabStop = false;
            // 
            // ReadCounterTimer
            // 
            this.ReadCounterTimer.Interval = 1;
            this.ReadCounterTimer.Tick += new System.EventHandler(this.ReadCounterTimer_Tick);
            // 
            // CompareLogic
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(954, 670);
            this.Controls.Add(this.GB_ModuleInfo);
            this.Controls.Add(this.GB_Counter);
            this.Controls.Add(this.GB_AcquisitionInfo);
            this.Controls.Add(this.B_CounterReleaseInitialisation);
            this.Controls.Add(this.B_StopCompare);
            this.Controls.Add(this.B_StartCompare);
            this.Controls.Add(this.B_ClearCounter);
            this.Controls.Add(this.B_CounterInitialisation);
            this.Controls.Add(this.GB_Compare);
            this.Controls.Add(this.GB_Help);
            this.Controls.Add(this.GB_CounterConfig);
            this.Controls.Add(this.groupBox2);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "CompareLogic";
            this.Text = "C# Counter(s) compare logic";
            this.Load += new System.EventHandler(this.CompareLogic_Load);
            this.Closed += new System.EventHandler(this.CompareLogic_Closed);
            this.groupBox2.ResumeLayout(false);
            this.GB_CounterConfig.ResumeLayout(false);
            this.GB_CounterConfig.PerformLayout();
            this.GB_Help.ResumeLayout(false);
            this.GB_Compare.ResumeLayout(false);
            this.GB_Compare.PerformLayout();
            this.GB_AcquisitionInfo.ResumeLayout(false);
            this.GB_AcquisitionInfo.PerformLayout();
            this.GB_ModuleInfo.ResumeLayout(false);
            this.GB_ModuleInfo.PerformLayout();
            this.GB_Counter.ResumeLayout(false);
            this.GB_Counter.PerformLayout();
            this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new CompareLogic());
		}

        public static String ConvertFromTime_T(byte[] bBuffer, int iIndex)
        {
            ulong ulTimeStampLow = BitConverter.ToUInt32(bBuffer, iIndex);
            ulong ulTimeStampHigh = BitConverter.ToUInt32(bBuffer, iIndex + 4);

            return (ConvertFromTime_T(ulTimeStampHigh, ulTimeStampLow));
        }

        public static String ConvertFromTime_T(ulong ulTimeStampHigh, ulong ulTimeStampLow)
        {
            ulong ulTimeStampLowms = (ulong)(ulTimeStampLow / 1000);
            ulong ulTimeStampLowmus = (ulong)(ulTimeStampLow % 1000);

            DateTime dt70 = new DateTime(1970, 1, 1, 0, 0, 0, 0);
            long tickTotal = dt70.Ticks + (long)(ulTimeStampHigh * 10000000L);
            DateTime netTimeT = new DateTime(tickTotal);
            return (netTimeT.ToString() + "." + ulTimeStampLowms.ToString("D3") + "." + ulTimeStampLowmus.ToString("D3"));
        }
        
        
        // Global Variable
		MXCommon_WebReference.MXCommon MX_Common;
		MSXE172x_WebReference.MSXE17xx MSXE17xx;
        Socket                         SocketClient = null;
        String                         DisplayText = "";
        AsyncClientStream              Client = null;
        CheckBox[]                     CounterCompareList;
        int                            Counters = 1;
        byte                           bValueFormat = 0;
        ulong                          CompareLogicCounter = 0;
        double                         dSiagnalPeriod = 0.0;

		private void CompareLogic_Load(object sender, System.EventArgs e)
		{
			MX_Common = new MXCommon_WebReference.MXCommon();
            MSXE17xx  = new MSXE172x_WebReference.MSXE17xx();
			MX_Common.Timeout = 2000;
            MSXE17xx.Timeout = 2000;

            ArrayList Resolution = new ArrayList();
            Resolution.Add(new ListData("16", 16));
            Resolution.Add(new ListData("32", 32));
            Resolution.Add(new ListData("40", 40));
            Resolution.Add(new ListData("64", 64));
            Resolution.Add(new ListData("80", 80));
            Resolution.Add(new ListData("100", 100));
            Resolution.Add(new ListData("128", 128));
            Resolution.Add(new ListData("160", 160));
            Resolution.Add(new ListData("200", 200));
            Resolution.Add(new ListData("256", 256));
            Resolution.Add(new ListData("320", 320));
            Resolution.Add(new ListData("400", 400));
            Resolution.Add(new ListData("500", 500));
            Resolution.Add(new ListData("512", 512));
            Resolution.Add(new ListData("800", 800));
            Resolution.Add(new ListData("1000", 1000));
            Resolution.Add(new ListData("1024", 1024));
            Resolution.Add(new ListData("1600", 1600));
            Resolution.Add(new ListData("2000", 2000));
            Resolution.Add(new ListData("2048", 2048));
            Resolution.Add(new ListData("4096", 4096));
            Resolution.Add(new ListData("8192", 8192));

            LB_SC_Resolution.DataSource = Resolution;
            LB_SC_Resolution.DisplayMember = "Item";
            LB_SC_Resolution.ValueMember = "Value";
            LB_SC_Resolution.SelectedIndex = 1;

            // Counter data format list box initialisation
            ArrayList ValueFormat = new ArrayList();
            ValueFormat.Add(new ListData("Raw data", 0));
            ValueFormat.Add(new ListData("Millimeters", 1));

            LB_SC_ValueFormat.DataSource = ValueFormat;
            LB_SC_ValueFormat.DisplayMember = "Item";
            LB_SC_ValueFormat.ValueMember = "Value";


            // Compare logic list box initialisation
            ArrayList CompareLogicMode = new ArrayList();
            CompareLogicMode.Add(new ListData("Equals compare value", 0));
            CompareLogicMode.Add(new ListData("Equals a multiple of the compare value (Modulo)", 1));

            LB_CompareLogic.DataSource = CompareLogicMode;
            LB_CompareLogic.DisplayMember = "Item";
            LB_CompareLogic.ValueMember = "Value";

            // Synchro trigger list box initialisation
            ArrayList SynchroTriggerMode = new ArrayList();
            SynchroTriggerMode.Add(new ListData("Disabled", 0));
            SynchroTriggerMode.Add(new ListData("Enabled", 1));

            LB_SynchroTrigger.DataSource = SynchroTriggerMode;
            LB_SynchroTrigger.DisplayMember = "Item";
            LB_SynchroTrigger.ValueMember = "Value";
            

            // Counter compare list initialisation
            CounterCompareList = new CheckBox[4];
            CounterCompareList[0] = CB_Counter0;
            CounterCompareList[1] = CB_Counter1;
            CounterCompareList[2] = CB_Counter2;
            CounterCompareList[3] = CB_Counter3;

            RB_Counter0.Checked = true;
        }


		private void CompareLogic_Closed(object sender, System.EventArgs e)
		{
            ReadCounterTimer.Enabled = false;

            CloseAll();

            if (MSXE17xx != null)
			{
                MSXE17xx = null;
			}
			if (MX_Common != null)
			{
				MX_Common = null;
			}

			System.GC.Collect();
		}

        private void CloseAll ()
        {
            // Test if any acquisition in progress
            if (B_StopCompare.Enabled == true)
            {
                // Test the current acquisition
                B_StopCompare_Click(null, null);
            }

            // Test if counter initialised
            if (B_CounterReleaseInitialisation.Enabled == true)
            {
                // Release the counter initialisation
                B_CounterReleaseInitialisation_Click(null, null);
            }
        }

        private void RB_CounterX_CheckedChanged(object sender, EventArgs e)
        {
            for (int i = 0; i < 4; i ++)
            {
                CounterCompareList[i].Enabled = true;
            }

            if (sender == RB_Counter0)
            {
                CompareLogicCounter = 0;
            }
            else if (sender == RB_Counter1)
            {
                CompareLogicCounter = 1;
            }
            else if (sender == RB_Counter2)
            {
                CompareLogicCounter = 2;
            }
            else
            {
                CompareLogicCounter = 3;
            }

            CounterCompareList[CompareLogicCounter].Enabled = false;
            CounterCompareList[CompareLogicCounter].Checked = true;
        }


        private void CB_CounterX_CheckedChanged(object sender, EventArgs e)
        {

            Counters = 0;

            for (int i = 0; i < 4; i++)
            {
                if (CounterCompareList[i].Checked == true)
                {
                    Counters++;
                }
            }

            if (Counters == 1)
            {
                LB_SynchroTrigger.Enabled = true;
            }
            else
            {
                LB_SynchroTrigger.Enabled = false;
                LB_SynchroTrigger.SelectedIndex = 1;
            }
        }

        private void LB_SC_ValueFormat_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (LB_SC_ValueFormat.SelectedIndex == 0)
            {
                L_Compare.Text = "Selected compare value";
            }
            else
            {
                L_Compare.Text = "Selected compare value (mm)";
            }
        }

        private void B_Connect_Click(object sender, EventArgs e)
        {
            byte[] bModuleType = new byte[200];
            System.Text.ASCIIEncoding ASCIIEnc = new System.Text.ASCIIEncoding();

            if ((TB_IPAddress_0.Text.ToString() == "") || (TB_IPAddress_1.Text.ToString() == "") || (TB_IPAddress_2.Text.ToString() == "") || (TB_IPAddress_3.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256))
                            {
                                CloseAll();

                                try
                                {
                                    MSXE17xx.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
                                    MX_Common.Url = MSXE17xx.Url;

                                    // Get the module type
                                    MX_Common.GetModuleType(out bModuleType);
                                    L_MSXEInfo.Text = ASCIIEnc.GetString(bModuleType);

                                    // Button initialisation
                                    B_CounterInitialisation.Enabled = true;
                                    B_CounterReleaseInitialisation.Enabled = false;
                                    B_ClearCounter.Enabled = false;
                                    B_StartCompare.Enabled = false;
                                    B_StopCompare.Enabled = false;
                                    GB_CounterConfig.Enabled = true;
                                    GB_Compare.Enabled = true;
                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                }
                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void B_CounterInitialisation_Click(object sender, EventArgs e)
        {
            ulong ulInfo1             = 0;
            ulong ulInfo2             = 0;
            ulong ulMaxInputFrequency = 0;
            MSXE172x_WebReference.DefaultResponse  Response = new MSXE172x_WebReference.DefaultResponse();

            MX_Common.Timeout = 2000;
            MSXE17xx.Timeout = 2000;

            try
            {
                dSiagnalPeriod = Convert.ToDouble(TB_SC_SignalPeriod.Text);
            }
            catch 
            {
                MessageBox.Show("Invalid format.", "Signal period", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            try
            {
                bValueFormat = Convert.ToByte(LB_SC_ValueFormat.SelectedValue);

                // Init the counter
                Response = MSXE17xx.MFSinCosInitEx(CompareLogicCounter, 
                                                   1,
                                                   dSiagnalPeriod,
                                                   Convert.ToUInt32(LB_SC_Resolution.SelectedValue),
                                                   Convert.ToUInt32(LB_SC_ValueFormat.SelectedValue), 
                                                   0, 
                                                   0, 
                                                   0, 
                                                   0, 
                                                   out ulMaxInputFrequency, 
                                                   out ulInfo1, 
                                                   out ulInfo2);

                if (Response.iReturnValue != 0)
                {
                    MessageBox.Show("MFSinCosInitEx Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                {
                    L_Frequency.Text = ulMaxInputFrequency.ToString() + " Hz";
                    // Button initialisation
                    B_CounterInitialisation.Enabled = false;
                    B_CounterReleaseInitialisation.Enabled = true;
                    B_ClearCounter.Enabled = true;
                    B_StartCompare.Enabled = true;
                    B_StopCompare.Enabled = false;
                    GB_CounterConfig.Enabled = false;
                    GB_Compare.Enabled = true;
                    ReadCounterTimer.Enabled = true;
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void B_CounterReleaseInitialisation_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            ReadCounterTimer.Enabled = false;

            try
            {
                // Release the counter initialisation
                RetValue = MSXE17xx.MFSinCosRelease(CompareLogicCounter, 0, 0, out syserno);

                // Init the counter
                if (RetValue != 0)
                {
                    MessageBox.Show("MFSinCosRelease Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
            catch (Exception ex)
            {
                if (sender != null)
                {
                    MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

            // Button initialisation
            B_CounterInitialisation.Enabled = true;
            B_CounterReleaseInitialisation.Enabled = false;
            B_ClearCounter.Enabled = false;
            B_StartCompare.Enabled = false;
            B_StopCompare.Enabled = false;
            GB_CounterConfig.Enabled = true;
            GB_Compare.Enabled = true;
        }

        private void B_ClearCounter_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            if (GB_Compare.Enabled == false)
            {
                // Clear counter(s)
                for (ulong i = 0; i < 4; i++)
                {
                    // Test if counter used
                    if (CounterCompareList[i].Checked == true)
                    {
                        try
                        {
                            // Clear the counter 
                            RetValue = MSXE17xx.MFSinCosClear(i, 0, 0, out syserno);

                            if (RetValue != 0)
                            {
                                MessageBox.Show("MFSinCosClear Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        catch (Exception ex)
                        {
                            MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                }
            }
            else
            {
                try
                {
                    // Clear the counter 
                    RetValue = MSXE17xx.MFSinCosClear(CompareLogicCounter, 0, 0, out syserno);

                    if (RetValue != 0)
                    {
                        MessageBox.Show("MFSinCosClear Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void B_StartCompare_Click(object sender, EventArgs e)
        {
            ulong FIFOSize    = Convert.ToUInt32(TB_TransferNbr.Text);
            Double CompareValue = Convert.ToDouble (TB_CompareValue.Text);
            ulong ulInfo1 = 0;
            ulong ulInfo2 = 0;
            ulong ulMaxInputFrequency = 0;
            int syserno = 0;
            int RetValue = 0;
            bool boErrorOccur = false;
            Thread ClientThread;
            MSXE172x_WebReference.DefaultResponse Response = new MSXE172x_WebReference.DefaultResponse();

            // Test the FIFO size
            if (FIFOSize < 1 || FIFOSize > 200)
            {
                MessageBox.Show("Number of compare to acquire not OK", "Configuration error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return;
            }

            // Create the client stream
            Client = new AddiData.ADDISocket.AsyncClientStream();

            // Open the socket connection to receive the data
            SocketClient = null;
            SocketClient = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            SocketClient.ReceiveBufferSize = 1048576;
            SocketClient.Connect(TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text, 8989);

            // Start the read socket and the user thread
            Client.SingleFramesSize = 5 * 4 * Counters;
            Client.NbrOfFrames = Convert.ToInt32(FIFOSize);
            Client.Start(SocketClient);
            ClientThread = new Thread(ClientThreadFct);
            DisplayText = "";

            // Counter(s) initialisation
            for (ulong i = 0; (i < 4) && (boErrorOccur == false); i++)
            {
                // Test if counter used
                if ((CounterCompareList[i].Checked == true) && (i != CompareLogicCounter))
                {
                    try
                    {
                        // Init the counter
                        Response = MSXE17xx.MFSinCosInitEx(i,
                                                           1,
                                                           dSiagnalPeriod,
                                                           Convert.ToUInt32(LB_SC_Resolution.SelectedValue),
                                                           Convert.ToUInt32(LB_SC_ValueFormat.SelectedValue),
                                                           0,
                                                           0,
                                                           0,
                                                           0,
                                                           out ulMaxInputFrequency,
                                                           out ulInfo1,
                                                           out ulInfo2);

                        if (Response.iReturnValue != 0)
                        {
                            MessageBox.Show("MFSinCosInitEx Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            boErrorOccur = true;
                        }
                    }

                    catch (Exception ex)
                    {
                        MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        boErrorOccur = true;
                    }
                }

                if (boErrorOccur == true)
                {
                    for (ulong j = 0; j < i; j++)
                    {
                        // Test if counter used
                        if ((CounterCompareList[j].Checked == true) && (j != CompareLogicCounter))
                        {
                            // Release the counter initialisation
                            MSXE17xx.MFSinCosRelease(j, 0, 0, out syserno);
                        }
                    }
                }
            }

            // FIFO initialisation
            for (ulong i = 0; (i < 4) && (boErrorOccur == false); i++)
            {
                // Test if counter used
                if (CounterCompareList[i].Checked == true)
                {
                    // Counter FIFO initialisation
                    RetValue = MSXE17xx.MFCommonSetFIFO0Level(i, FIFOSize, 0, 0, 0, 0, out syserno);

                    if (RetValue != 0)
                    {
                        MessageBox.Show("MFCommonSetFIFO0Level Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        boErrorOccur = true;
                    }
                    else
                    {
                        if (i != CompareLogicCounter)
                        {
                            // Synchro latch initialisation
                            RetValue = MSXE17xx.MFSinCosInitAndEnableLatch(i, 2, 0, 1, 0, 0, out syserno);

                            if (RetValue != 0)
                            {
                                boErrorOccur = true;
                                MessageBox.Show("MFSinCosInitAndEnableLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            // Compare initialisation
                            RetValue = MSXE17xx.MFSinCosInitAndEnableCompareLogic(i, CompareValue, Convert.ToUInt32(LB_CompareLogic.SelectedValue), Convert.ToUInt32(LB_SynchroTrigger.SelectedValue), 0, 0, out syserno);

                            if (RetValue != 0)
                            {
                                boErrorOccur = true;
                                MessageBox.Show("MFSinCosInitAndEnableCompareLogic Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                            else if (Convert.ToUInt32(LB_SynchroTrigger.SelectedValue) == 1)
                            {
                                // Synchro latch initialisation
                                RetValue = MSXE17xx.MFSinCosInitAndEnableLatch(i, 2, 0, 1, 0, 0, out syserno);

                                if (RetValue != 0)
                                {
                                    boErrorOccur = true;
                                    MessageBox.Show("MFSinCosInitAndEnableLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                }
                            }
                        }
                    }

                    if (boErrorOccur == true)
                    {
                        for (ulong j = 0; j < i; j++)
                        {
                            // Test if counter used
                            if ((CounterCompareList[j].Enabled == true) && (j != CompareLogicCounter))
                            {
                                MSXE17xx.MFSinCosDisableAndReleaseLatch(j, 2, 0, out syserno);
                            }
                            else
                            {
                                MSXE17xx.MFSinCosDisableAndReleaseCompareLogic(j, out syserno);
                            }
                        }
                    }
                }
            }


            // Test if no error occur
            if (boErrorOccur == false)
            {
                    // Start the display timer and read socket thread
                    DisplayTimer.Enabled = true;
                    ClientThread.Priority = ThreadPriority.Lowest;
                    ClientThread.Start();

                    // Button initialisation
                    B_CounterInitialisation.Enabled = false;
                    B_CounterReleaseInitialisation.Enabled = false;
                    B_ClearCounter.Enabled = true;
                    B_StartCompare.Enabled = false;
                    B_StopCompare.Enabled = true;
                    GB_CounterConfig.Enabled = false;
                    GB_Compare.Enabled = false;
            }

            // Test if error occur
            if (boErrorOccur == true)
            {
                // Stop the data server 
                Client.Stoop();

                try
                {
                    // Close the socket connection
                    SocketClient.Shutdown(SocketShutdown.Both);
                    SocketClient.Close();
                    SocketClient = null;
                    System.GC.Collect();
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }
        }

        private void B_StopCompare_Click(object sender, EventArgs e)
        {
            int syserno = 0;
            int RetValue = 0;

            // Stop the data server 
            Client.Stoop();

            try
            {
                // Close the socket connection
                SocketClient.Shutdown(SocketShutdown.Both);
                SocketClient.Close();
                SocketClient = null;
                System.GC.Collect();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Socket close connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }

            // Disable synchro latch from counter(s)
            for (ulong i = 0; i < 4; i++)
            {
                // Test if counter used
                if (CounterCompareList[i].Checked == true)
                {
                    if (i != CompareLogicCounter)
                    {
                        try
                        {
                            // Disable the syncho latch
                            RetValue = MSXE17xx.MFSinCosDisableAndReleaseLatch(i, 2, 0, out syserno);

                            if (RetValue != 0)
                            {
                                MessageBox.Show("MFSinCosDisableAndReleaseLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        catch (Exception ex)
                        {
                            if (sender != null)
                            {
                                MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }

                        try
                        {
                            // Release the counter initialisation
                            RetValue = MSXE17xx.MFSinCosRelease(i, 0, 0, out syserno);

                            if (RetValue != 0)
                            {
                                MessageBox.Show("MFSinCosDisableAndReleaseLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        catch (Exception ex)
                        {
                            if (sender != null)
                            {
                                MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                    }
                    else
                    {
                        try
                        {
                            // Disable the compare logic
                            RetValue = MSXE17xx.MFSinCosDisableAndReleaseCompareLogic(i, out syserno);

                            if (RetValue != 0)
                            {
                                MessageBox.Show("MFSinCosDisableAndReleaseCompareLogic Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                            else if (Convert.ToUInt32(LB_SynchroTrigger.SelectedValue) == 1)
                            {
                                // Disable the syncho latch
                                RetValue = MSXE17xx.MFSinCosDisableAndReleaseLatch(i, 2, 0, out syserno);

                                if (RetValue != 0)
                                {
                                    MessageBox.Show("MFSinCosDisableAndReleaseLatch Error : " + RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            if (sender != null)
                            {
                                MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                    }
                }
            }

            // Button initialisation
            B_CounterInitialisation.Enabled = false;
            B_CounterReleaseInitialisation.Enabled = true;
            B_ClearCounter.Enabled = true;
            B_StartCompare.Enabled = true;
            B_StopCompare.Enabled = false;
            GB_CounterConfig.Enabled = false;
            GB_Compare.Enabled = true;
        }

        private void ClientThreadFct()
        {
            byte[] SocketData;
            int StreamCounter = 0;
            int Offset = 0;
            int Counter = 0;
            ulong Source = 0;
            ulong AcquisitionCounter = 0;
            String sOutString;
            Single fValue;

            while ((SocketData = Client.ReadData()) != null)
            {
                sOutString = "";
                Offset = 0;

                for (StreamCounter = 0; StreamCounter < Client.NbrOfFrames; StreamCounter++)
                {
                    for (Counter = 0; Counter < Counters; Counter++)
                    {
                        Offset = (StreamCounter + (Client.NbrOfFrames * Counter)) * 5 * 4;
                        // 
                        sOutString = sOutString + "Acquisition counter: " + AcquisitionCounter.ToString();

                        // Get the time stamp
                        sOutString = sOutString + " / Time stamp: " + ConvertFromTime_T(SocketData, Offset);
                        Offset = Offset + 8;

                        // Get the counter nbr
                        sOutString = sOutString + " / counter: " + (BitConverter.ToUInt32(SocketData, Offset) & 3).ToString();
                        Offset = Offset + 4;

                        // Get the source
                        Source = BitConverter.ToUInt32(SocketData, Offset);
                        sOutString = sOutString + " / source: " + (Source & 0x7FFFFFFFUL).ToString();
                        Offset = Offset + 4;

                        // Get the counter value
                        if (bValueFormat == 0)
                        {
                            sOutString = sOutString + " / value: " + BitConverter.ToUInt32(SocketData, Offset).ToString();
                        }
                        else
                        {
                            fValue = BitConverter.ToSingle(SocketData, Offset);

                            if (Math.Abs(fValue) < 0.0001)
                            {
                                if (Math.Abs(fValue) < 0.0000001)
                                {
                                    sOutString = sOutString + " / position: " + (fValue * 1000000.0).ToString("F3") + "nm";
                                }
                                else
                                {
                                    sOutString = sOutString + " / position: " + (fValue * 1000.0).ToString("F3") + "m";
                                }
                            }
                            else
                            {
                                sOutString = sOutString + " / position: " + fValue.ToString("F3") + "mm";
                            }
                        }

                        // Test if measure error occur
                        sOutString = sOutString + " / error: " + (Source >> 31).ToString() + Environment.NewLine;

                        AcquisitionCounter++;
                    }
                }

                DisplayText = DisplayText + sOutString;
            }
        }

        private void DisplayTimer_Tick(object sender, EventArgs e)
        {
            TB_Values.Text = DisplayText;
        }

        private void ReadCounterTimer_Tick(object sender, EventArgs e)
        {
            bool Error = false;
            Double CounterValue;
            ulong MeasureError;
            ulong Info1; 
            ulong Info2;
            String sOut = "";
            MSXE172x_WebReference.DefaultResponse Response = new MSXE172x_WebReference.DefaultResponse();

            try
            {
                // Read the counter value
                Response = MSXE17xx.MFSinCosReadEx(CompareLogicCounter, 0, 0, 0, 0, out CounterValue, out MeasureError, out Info1, out Info2);

                if (Response.iReturnValue != 0)
                {
                    CloseAll();
                    MessageBox.Show("MFSinCosReadEx Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    Error = true;
                }
                else
                {
                    // Get the counter value
                    if (bValueFormat == 0)
                    {
                        sOut = "Counter value = " + CounterValue.ToString();
                    }
                    else
                    {
                        if (Math.Abs(CounterValue) < 0.0001)
                        {
                            if (Math.Abs(CounterValue) < 0.0000001)
                            {
                                sOut = "Counter position = " + (CounterValue * 1000000.0).ToString("F3") + "nm";
                            }
                            else
                            {
                                sOut = "Counter position = " + (CounterValue * 1000.0).ToString("F3") + "m";
                            }
                        }
                        else
                        {
                            sOut = "Counter position = " + CounterValue.ToString("F3") + "mm";
                        }

                        if ((MeasureError & 1) == 1)
                            sOut = sOut + " / amplitude error";

                        if ((MeasureError & 2) == 2)
                            sOut = sOut + " / frequency error";

                    }
                }
            }
            catch (Exception ex)
            {
                MX_Common.Timeout = 500;
                MSXE17xx.Timeout = 500;
                CloseAll();
                MessageBox.Show("SOAP connection exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                Error = true;
            }

            // Test if error occur
            if (Error != true)
            {
                TB_CounterCompare.Text = sOut;
            }
        }
    }
}
